# coding: utf-8

"""
    Orbit Extrapolation API

    Orbit Extrapolation API

    The version of the OpenAPI document: 1.1.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class DatedLofImpulse(BaseModel):
    """
    Impulsive Delta-V (instantaneous velocity increment) in a LOF triggered at a given date
    """ # noqa: E501
    execution_date: Optional[str] = Field(default=None, description="timescale UTC", alias="executionDate")
    delta_vx: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Units [m/s]", alias="deltaVx")
    delta_vy: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Units [m/s]", alias="deltaVy")
    delta_vz: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Units [m/s]", alias="deltaVz")
    __properties: ClassVar[List[str]] = ["executionDate", "deltaVx", "deltaVy", "deltaVz"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DatedLofImpulse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DatedLofImpulse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "executionDate": obj.get("executionDate"),
            "deltaVx": obj.get("deltaVx"),
            "deltaVy": obj.get("deltaVy"),
            "deltaVz": obj.get("deltaVz")
        })
        return _obj


