# coding: utf-8

"""
    Orbit Extrapolation API

    Orbit Extrapolation API

    The version of the OpenAPI document: 1.1.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class InitialOrbitType(str, Enum):
    """
    Type of parameters that can be used to describe the instantaneous state of an orbiting body.  Any kind of orbital parameters can be used for initializing an osculating orbit.<br> Mean orbits instead should be initialized using orbital elements consistent with the underlying theory (the position angle type is always ```MEAN```).<br>  Select:<br> - ```CIRCULAR``` orbitType for ```MEAN_ECKSTEIN_HECHLER``` theory - ```EQUINOCTIAL``` for ```MEAN_DSST_6X0``` theory - ```KEPLERIAN``` for ```MEAN_BROUWER_LYDDANE``` theory 
    """

    """
    allowed enum values
    """
    KEPLERIAN = 'KEPLERIAN'
    CIRCULAR = 'CIRCULAR'
    EQUINOCTIAL = 'EQUINOCTIAL'
    CARTESIAN = 'CARTESIAN'
    TLE_ORBIT = 'TLE_ORBIT'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of InitialOrbitType from a JSON string"""
        return cls(json.loads(json_str))


